Bug 14862 - [intel] better gamma value setting on 945GM video overlay
Summary: [intel] better gamma value setting on 945GM video overlay
Status: RESOLVED FIXED
Alias: None
Product: xorg
Classification: Unclassified
Component: Driver/intel (show other bugs)
Version: unspecified
Hardware: x86 (IA32) Linux (All)
: medium normal
Assignee: Wang Zhenyu
QA Contact: Xorg Project Team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-03-06 12:19 UTC by Anton Khirnov
Modified: 2008-04-09 00:18 UTC (History)
1 user (show)

See Also:
i915 platform:
i915 features:


Attachments

Description Anton Khirnov 2008-03-06 12:19:14 UTC
As the subject says, overlay (textured video is ok) on 945GM has wrong gamma levels. The most noticeable effect is that black appears much brighter than it should (just compare to textured video/Xshm/gl) and it cannot be fixed just adjusting brightness.
Comment 1 Wang Zhenyu 2008-03-06 22:39:41 UTC
overlay has several XV_GAMMA attributes for change. That should be your need.
Comment 2 Anton Khirnov 2008-03-06 23:34:50 UTC
I know about them, but there are just too many settings and there's no docs about them so I don't know what values should I use.
Comment 3 Wang Zhenyu 2008-03-07 00:08:09 UTC
yeah, sorry for that. We just expose the hardware attributes directly in software without explain, which is bad and better to be fixed obvious for normal gamma change.

Docs on those 6 GAMMA points are intel specs, you can find them at http://www.x.org/docs/intel/. You may look for OGAMC definition in Display Register chapter.

So they're 6 break points in color space for gamma correction, end-to-end is fixed at 0 and 255. 6 points apply to values at 8,16,32,64,128,192.

Each register is 32bit for 8bit each RGB or VYU. You may see from i830_video.c that we just set linear values by default.

Comment 4 Wang Zhenyu 2008-03-19 18:55:14 UTC
Change topic a little.
Comment 5 Eric Anholt 2008-04-08 12:48:25 UTC
I just pushed a fix which would improve the default colorspace conversion factors for overlay, particularly around black.  You may want to retest.  We're still a little bit wrong, but it may be impossible to be right pre-965 overlay (textured should of course be correct)
Comment 6 Anton Khirnov 2008-04-08 23:40:39 UTC
Wow, I'm impressed. As far as I can see, it's indistinguishable from textured video now, so this bug can probably be closed.
Thanks for fixing it.
Comment 7 Wang Zhenyu 2008-04-09 00:18:59 UTC
Thanks to verify. Close this.


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.